﻿using Microsoft.AnalysisServices.Tabular;

namespace AddMeasure {
    class Program {
        static void Main(string[] args) {
            AddOrChangeMeasure();
        }
        public static void AddOrChangeMeasure() {
            string serverName = @"localhost\tabular";
            string databaseName = "Contoso";
            string tableName = "Sales";
            string measureName = "Total Sales";
            string measureExpression = "SUMX ( Sales, Sales[Quantity] * Sales[Net Price] )";

            string serverConnectionString = string.Format("Provider=MSOLAP;Data Source={0}", serverName);

            Server server = new Server();
            server.Connect(serverConnectionString);

            Database db = server.Databases[databaseName];
            Model model = db.Model;
            Table table = model.Tables[tableName];
            Measure measure = table.Measures.Find(measureName);
            if (measure == null) {
                measure = new Measure() { Name = measureName };
                table.Measures.Add(measure);
            }
            measure.Expression = measureExpression;
            model.SaveChanges();
        }
        public static void AddMeasure() {
            string serverName = @"localhost\tabular";
            string databaseName = "Contoso";
            string tableName = "Sales";
            string measureName = "Total Sales";
            string measureExpression = "SUMX ( Sales, Sales[Quantity] * Sales[Net Price] )";

            string serverConnectionString = string.Format("Provider=MSOLAP;Data Source={0}", serverName);

            Server server = new Server();
            server.Connect(serverConnectionString);

            Database db = server.Databases[databaseName];
            Model model = db.Model;
            Table table = model.Tables[tableName];
            table.Measures.Add(new Measure() { Name = measureName, Expression = measureExpression });
            model.SaveChanges();
        }
    }
}
