﻿[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.AnalysisServices.Tabular")
$serverName = "localhost\tabular";
$databaseName = "Contoso";
$tableName = "Sales";
$measureName = "Total Sales1";
$measureExpression = "SUMX ( Sales, Sales[Quantity] * Sales[Net Price] )";

$svr = new-Object Microsoft.AnalysisServices.Tabular.Server
$svr.Connect($serverName)
$database = $svr.databases
$db = $database.GetByName($databaseName)
$table = $db.Model.Tables.Item($tableName)
$measure = $table.Measures.Find($measureName)
if ($measure -eq $null) {
    $measure = new-Object Microsoft.AnalysisServices.Tabular.Measure
    $measure.Name = $measureName
    $table.Measures.Add( $measure )
}
$measure.Expression = $measureExpression
$db.Model.SaveChanges()